Whamcloud - gitweb
5337a4293df6443fa86605629621493e105c3584
[fs/lustre-release.git] / lustre / tests / sanity.sh
1 #!/bin/bash
2 #
3 # Run select tests by setting ONLY, or as arguments to the script.
4 # Skip specific tests by setting EXCEPT.
5 #
6 # e.g. ONLY="22 23" or ONLY="`seq 32 39`" or EXCEPT="31"
7 set -e
8
9 ONLY=${ONLY:-"$*"}
10 # bug number for skipped test: 
11 ALWAYS_EXCEPT=${ALWAYS_EXCEPT:-""}
12 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
13
14 [ "$ALWAYS_EXCEPT$EXCEPT" ] && echo "Skipping tests: $ALWAYS_EXCEPT $EXCEPT"
15
16 SRCDIR=`dirname $0`
17 PATH=$PWD/$SRCDIR:$SRCDIR:$SRCDIR/../utils:$PATH
18
19 TMP=${TMP:-/tmp}
20
21 CHECKSTAT=${CHECKSTAT:-"checkstat -v"}
22 CREATETEST=${CREATETEST:-createtest}
23 LFIND=${LFIND:-lfind}
24 LSTRIPE=${LSTRIPE:-lstripe}
25 LCTL=${LCTL:-lctl}
26 MCREATE=${MCREATE:-mcreate}
27 OPENFILE=${OPENFILE:-openfile}
28 OPENUNLINK=${OPENUNLINK:-openunlink}
29 TOEXCL=${TOEXCL:-toexcl}
30 TRUNCATE=${TRUNCATE:-truncate}
31 MUNLINK=${MUNLINK:-munlink}
32 SOCKETSERVER=${SOCKETSERVER:-socketserver}
33 SOCKETCLIENT=${SOCKETCLIENT:-socketclient}
34 IOPENTEST1=${IOPENTEST1:-iopentest1}
35 IOPENTEST2=${IOPENTEST2:-iopentest2}
36
37 if [ $UID -ne 0 ]; then
38         RUNAS_ID="$UID"
39         RUNAS=""
40 else
41         RUNAS_ID=${RUNAS_ID:-500}
42         RUNAS=${RUNAS:-"runas -u $RUNAS_ID"}
43 fi
44
45 export NAME=${NAME:-local}
46
47 SAVE_PWD=$PWD
48
49 clean() {
50         echo -n "cln.."
51         sh llmountcleanup.sh > /dev/null || exit 20
52         I_MOUNTED=no
53 }
54 CLEAN=${CLEAN:-clean}
55
56 start() {
57         echo -n "mnt.."
58         sh llrmount.sh > /dev/null || exit 10
59         I_MOUNTED=yes
60         echo "done"
61 }
62 START=${START:-start}
63
64 log() {
65         echo "$*"
66         lctl mark "$*" 2> /dev/null || true
67 }
68
69 run_one() {
70         if ! mount | grep -q $DIR; then
71                 $START
72         fi
73         log "== test $1: $2"
74         export TESTNAME=test_$1
75         test_$1 || error "test_$1: exit with rc=$?"
76         unset TESTNAME
77         pass
78         cd $SAVE_PWD
79         $CLEAN
80 }
81
82 build_test_filter() {
83         for O in $ONLY; do
84             eval ONLY_${O}=true
85         done
86         for E in $EXCEPT $ALWAYS_EXCEPT; do
87             eval EXCEPT_${E}=true
88         done
89 }
90
91 _basetest() {
92     echo $*
93 }
94
95 basetest() {
96     IFS=abcdefghijklmnopqrstuvwxyz _basetest $1
97 }
98
99 run_test() {
100          base=`basetest $1`
101          if [ "$ONLY" ]; then
102                  testname=ONLY_$1
103                  if [ ${!testname}x != x ]; then
104                         run_one $1 "$2"
105                         return $?
106                  fi
107                  testname=ONLY_$base
108                  if [ ${!testname}x != x ]; then
109                          run_one $1 "$2"
110                          return $?
111                  fi
112                  echo -n "."
113                  return 0
114         fi
115         testname=EXCEPT_$1
116         if [ ${!testname}x != x ]; then
117                  echo "skipping excluded test $1"
118                  return 0
119         fi
120         testname=EXCEPT_$base
121         if [ ${!testname}x != x ]; then
122                  echo "skipping excluded test $1 (base $base)"
123                  return 0
124         fi
125         run_one $1 "$2"
126         return $?
127 }
128
129 [ "$SANITYLOG" ] && rm -f $SANITYLOG || true
130
131 error() { 
132         log "FAIL: $@"
133         if [ "$SANITYLOG" ]; then
134                 echo "FAIL: $TESTNAME $@" >> $SANITYLOG
135         else
136                 exit 1
137         fi
138 }
139
140 pass() { 
141         echo PASS
142 }
143
144 MOUNT="`mount | awk '/^'$NAME' .* lustre_lite / { print $3 }'`"
145 if [ -z "$MOUNT" ]; then
146         sh llmount.sh
147         MOUNT="`mount | awk '/^'$NAME' .* lustre_lite / { print $3 }'`"
148         [ -z "$MOUNT" ] && error "NAME=$NAME not mounted"
149         I_MOUNTED=yes
150 fi
151
152 [ `echo $MOUNT | wc -w` -gt 1 ] && error "NAME=$NAME mounted more than once"
153
154 DIR=${DIR:-$MOUNT}
155 [ -z "`echo $DIR | grep $MOUNT`" ] && echo "$DIR not in $MOUNT" && exit 99
156
157 LOVNAME=`cat /proc/fs/lustre/llite/fs0/lov/common_name`
158 STRIPECOUNT=`cat /proc/fs/lustre/lov/$LOVNAME/numobd`
159
160 [ -f $DIR/d52a/foo ] && chattr -a $DIR/d52a/foo
161 [ -f $DIR/d52b/foo ] && chattr -i $DIR/d52b/foo
162 rm -rf $DIR/[Rdfs][1-9]*
163
164 build_test_filter
165
166 echo preparing for tests involving mounts
167 EXT2_DEV=${EXT2_DEV:-/tmp/SANITY.LOOP}
168 touch $EXT2_DEV
169 mke2fs -F $EXT2_DEV 1000 > /dev/null
170
171 EXT3_DEV=${EXT3_DEV:-/tmp/SANITY_EXT3_DEV.LOOP}
172 touch $EXT3_DEV
173 mkfs.ext3 -F $EXT3_DEV 10000 > /dev/null
174
175 test_0() {
176         touch $DIR/f
177         $CHECKSTAT -t file $DIR/f || error
178         rm $DIR/f
179         $CHECKSTAT -a $DIR/f || error
180 }
181 run_test 0 "touch .../f ; rm .../f ============================="
182
183 test_1a() {
184         mkdir $DIR/d1
185         mkdir $DIR/d1/d2
186         $CHECKSTAT -t dir $DIR/d1/d2 || error
187 }
188 run_test 1a "mkdir .../d1; mkdir .../d1/d2 ====================="
189
190 test_1b() {
191         rmdir $DIR/d1/d2
192         rmdir $DIR/d1
193         $CHECKSTAT -a $DIR/d1 || error
194 }
195 run_test 1b "rmdir .../d1/d2; rmdir .../d1 ====================="
196
197 test_2a() {
198         mkdir $DIR/d2
199         touch $DIR/d2/f
200         $CHECKSTAT -t file $DIR/d2/f || error
201 }
202 run_test 2a "mkdir .../d2; touch .../d2/f ======================"
203
204 test_2b() {
205         rm -r $DIR/d2
206         $CHECKSTAT -a $DIR/d2 || error
207 }
208 run_test 2b "rm -r .../d2; checkstat .../d2/f ======================"
209
210 test_3a() {
211         mkdir $DIR/d3
212         $CHECKSTAT -t dir $DIR/d3 || error
213 }
214 run_test 3a "mkdir .../d3 ======================================"
215
216 test_3b() {
217         if [ ! -d $DIR/d3 ]; then
218                 mkdir $DIR/d3
219         fi
220         touch $DIR/d3/f
221         $CHECKSTAT -t file $DIR/d3/f || error
222 }
223 run_test 3b "touch .../d3/f ===================================="
224
225 test_3c() {
226         rm -r $DIR/d3
227         $CHECKSTAT -a $DIR/d3 || error
228 }
229 run_test 3c "rm -r .../d3 ======================================"
230
231 test_4a() {
232         mkdir $DIR/d4
233         $CHECKSTAT -t dir $DIR/d4 || error
234 }
235 run_test 4a "mkdir .../d4 ======================================"
236
237 test_4b() {
238         if [ ! -d $DIR/d4 ]; then
239                 mkdir $DIR/d4
240         fi
241         mkdir $DIR/d4/d2
242         $CHECKSTAT -t dir $DIR/d4/d2 || error
243 }
244 run_test 4b "mkdir .../d4/d2 ==================================="
245
246 test_5() {
247         mkdir $DIR/d5
248         mkdir $DIR/d5/d2
249         chmod 0707 $DIR/d5/d2
250         $CHECKSTAT -t dir -p 0707 $DIR/d5/d2 || error
251 }
252 run_test 5 "mkdir .../d5 .../d5/d2; chmod .../d5/d2 ============"
253
254 test_6a() {
255         touch $DIR/f6a
256         chmod 0666 $DIR/f6a || error
257         $CHECKSTAT -t file -p 0666 -u \#$UID $DIR/f6a || error
258 }
259 run_test 6a "touch .../f6a; chmod .../f6a ======================"
260
261 test_6b() {
262         [ $RUNAS_ID -eq $UID ] && echo "skipping test 6b" && return
263         if [ ! -f $DIR/f6a ]; then
264                 touch $DIR/f6a
265                 chmod 0666 $DIR/f6a
266         fi
267         $RUNAS chmod 0444 $DIR/f6a && error
268         $CHECKSTAT -t file -p 0666 -u \#$UID $DIR/f6a || error
269 }
270 run_test 6b "$RUNAS chmod .../f6a (should return error) =="
271
272 test_6c() {
273         [ $RUNAS_ID -eq $UID ] && echo "skipping test 6c" && return
274         touch $DIR/f6c
275         chown $RUNAS_ID $DIR/f6c || error
276         $CHECKSTAT -t file -u \#$RUNAS_ID $DIR/f6c || error
277 }
278 run_test 6c "touch .../f6c; chown .../f6c ======================"
279
280 test_6d() {
281         [ $RUNAS_ID -eq $UID ] && echo "skipping test 6d" && return
282         if [ ! -f $DIR/f6c ]; then
283                 touch $DIR/f6c
284                 chown $RUNAS_ID $DIR/f6c
285         fi
286         $RUNAS chown $UID $DIR/f6c && error
287         $CHECKSTAT -t file -u \#$RUNAS_ID $DIR/f6c || error
288 }
289 run_test 6d "$RUNAS chown .../f6c (should return error) =="
290
291 test_6e() {
292         [ $RUNAS_ID -eq $UID ] && echo "skipping test 6e" && return
293         touch $DIR/f6e
294         chgrp $RUNAS_ID $DIR/f6e || error
295         $CHECKSTAT -t file -u \#$UID -g \#$RUNAS_ID $DIR/f6e || error
296 }
297 run_test 6e "touch .../f6e; chgrp .../f6e ======================"
298
299 test_6f() {
300         [ $RUNAS_ID -eq $UID ] && echo "skipping test 6f" && return
301         if [ ! -f $DIR/f6e ]; then
302                 touch $DIR/f6e
303                 chgrp $RUNAS_ID $DIR/f6e
304         fi
305         $RUNAS chgrp $UID $DIR/f6e && error
306         $CHECKSTAT -t file -u \#$UID -g \#$RUNAS_ID $DIR/f6e || error
307 }
308 run_test 6f "$RUNAS chgrp .../f6e (should return error) =="
309
310 test_6g() {
311         [ $RUNAS_ID -eq $UID ] && echo "skipping test 6g" && return
312         mkdir $DIR/d6g || error
313         chmod 777 $DIR/d6g || error
314         $RUNAS mkdir $DIR/d6g/d || error
315         chmod g+s $DIR/d6g/d || error
316         mkdir $DIR/d6g/d/subdir
317         $CHECKSTAT -g \#$RUNAS_ID $DIR/d6g/d/subdir || error
318 }
319 run_test 6g "Is new dir in sgid dir inheriting group?"
320
321 test_7a() {
322         mkdir $DIR/d7
323         $MCREATE $DIR/d7/f
324         chmod 0666 $DIR/d7/f
325         $CHECKSTAT -t file -p 0666 $DIR/d7/f || error
326 }
327 run_test 7a "mkdir .../d7; mcreate .../d7/f; chmod .../d7/f ===="
328
329 test_7b() {
330         if [ ! -d $DIR/d7 ]; then
331                 mkdir $DIR/d7
332         fi
333         $MCREATE $DIR/d7/f2
334         echo -n foo > $DIR/d7/f2
335         [ "`cat $DIR/d7/f2`" = "foo" ] || error
336         $CHECKSTAT -t file -s 3 $DIR/d7/f2 || error
337 }
338 run_test 7b "mkdir .../d7; mcreate d7/f2; echo foo > d7/f2 ====="
339
340 test_8() {
341         mkdir $DIR/d8
342         touch $DIR/d8/f
343         chmod 0666 $DIR/d8/f
344         $CHECKSTAT -t file -p 0666 $DIR/d8/f || error
345 }
346 run_test 8 "mkdir .../d8; touch .../d8/f; chmod .../d8/f ======="
347
348 test_9() {
349         mkdir $DIR/d9
350         mkdir $DIR/d9/d2
351         mkdir $DIR/d9/d2/d3
352         $CHECKSTAT -t dir $DIR/d9/d2/d3 || error
353 }
354 run_test 9 "mkdir .../d9 .../d9/d2 .../d9/d2/d3 ================"
355
356 test_10() {
357         mkdir $DIR/d10
358         mkdir $DIR/d10/d2
359         touch $DIR/d10/d2/f
360         $CHECKSTAT -t file $DIR/d10/d2/f || error
361 }
362 run_test 10 "mkdir .../d10 .../d10/d2; touch .../d10/d2/f ======"
363
364 test_11() {
365         mkdir $DIR/d11
366         mkdir $DIR/d11/d2
367         chmod 0666 $DIR/d11/d2
368         chmod 0705 $DIR/d11/d2
369         $CHECKSTAT -t dir -p 0705 $DIR/d11/d2 || error
370 }
371 run_test 11 "mkdir .../d11 d11/d2; chmod .../d11/d2 ============"
372
373 test_12() {
374         mkdir $DIR/d12
375         touch $DIR/d12/f
376         chmod 0666 $DIR/d12/f
377         chmod 0654 $DIR/d12/f
378         $CHECKSTAT -t file -p 0654 $DIR/d12/f || error
379 }
380 run_test 12 "touch .../d12/f; chmod .../d12/f .../d12/f ========"
381
382 test_13() {
383         mkdir $DIR/d13
384         dd if=/dev/zero of=$DIR/d13/f count=10
385         >  $DIR/d13/f
386         $CHECKSTAT -t file -s 0 $DIR/d13/f || error
387 }
388 run_test 13 "creat .../d13/f; dd .../d13/f; > .../d13/f ========"
389
390 test_14() {
391         mkdir $DIR/d14
392         touch $DIR/d14/f
393         rm $DIR/d14/f
394         $CHECKSTAT -a $DIR/d14/f || error
395 }
396 run_test 14 "touch .../d14/f; rm .../d14/f; rm .../d14/f ======="
397
398 test_15() {
399         mkdir $DIR/d15
400         touch $DIR/d15/f
401         mv $DIR/d15/f $DIR/d15/f2
402         $CHECKSTAT -t file $DIR/d15/f2 || error
403 }
404 run_test 15 "touch .../d15/f; mv .../d15/f .../d15/f2 =========="
405
406 test_16() {
407         mkdir $DIR/d16
408         touch $DIR/d16/f
409         rm -rf $DIR/d16/f
410         $CHECKSTAT -a $DIR/d16/f || error
411 }
412 run_test 16 "touch .../d16/f; rm -rf .../d16/f ================="
413
414 test_17a() {
415         mkdir $DIR/d17
416         touch $DIR/d17/f
417         ln -s $DIR/d17/f $DIR/d17/l-exist
418         ls -l $DIR/d17
419         $CHECKSTAT -l $DIR/d17/f $DIR/d17/l-exist || error
420         $CHECKSTAT -f -t f $DIR/d17/l-exist || error
421         rm -f $DIR/l-exist
422         $CHECKSTAT -a $DIR/l-exist || error
423 }
424 run_test 17a "symlinks: create, remove (real) =================="
425
426 test_17b() {
427         if [ ! -d $DIR/d17 ]; then
428                 mkdir $DIR/d17
429         fi
430         ln -s no-such-file $DIR/d17/l-dangle
431         ls -l $DIR/d17
432         $CHECKSTAT -l no-such-file $DIR/d17/l-dangle || error
433         $CHECKSTAT -fa $DIR/d17/l-dangle || error
434         rm -f $DIR/l-dangle
435         $CHECKSTAT -a $DIR/l-dangle || error
436 }
437 run_test 17b "symlinks: create, remove (dangling) =============="
438
439 test_18() {
440         touch $DIR/f
441         ls $DIR || error
442 }
443 run_test 18 "touch .../f ; ls ... =============================="
444
445 test_19a() {
446         touch $DIR/f19
447         ls -l $DIR
448         rm $DIR/f19
449         $CHECKSTAT -a $DIR/f19 || error
450 }
451 run_test 19a "touch .../f19 ; ls -l ... ; rm .../f19 ==========="
452
453 test_19b() {
454         ls -l $DIR/f19 && error || true
455 }
456 run_test 19b "ls -l .../f19 (should return error) =============="
457
458 test_19c() {
459         [ $RUNAS_ID -eq $UID ] && echo "skipping test 19c" && return
460         $RUNAS touch $DIR/f19 && error || true
461 }
462 run_test 19c "$RUNAS touch .../f19 (should return error) =="
463
464 test_19d() {
465         cat $DIR/f19 && error || true
466 }
467 run_test 19d "cat .../f19 (should return error) =============="
468
469 test_20() {
470         touch $DIR/f
471         rm $DIR/f
472         log "1 done"
473         touch $DIR/f
474         rm $DIR/f
475         log "2 done"
476         touch $DIR/f
477         rm $DIR/f
478         log "3 done"
479         $CHECKSTAT -a $DIR/f || error
480 }
481 run_test 20 "touch .../f ; ls -l ... ==========================="
482
483 test_21() {
484         mkdir $DIR/d21
485         [ -f $DIR/d21/dangle ] && rm -f $DIR/d21/dangle
486         ln -s dangle $DIR/d21/link
487         echo foo >> $DIR/d21/link
488         cat $DIR/d21/dangle
489         $CHECKSTAT -t link $DIR/d21/link || error
490         $CHECKSTAT -f -t file $DIR/d21/link || error
491 }
492 run_test 21 "write to dangling link ============================"
493
494 test_22() {
495         mkdir $DIR/d22
496         chown $RUNAS_ID $DIR/d22
497         # Tar gets pissy if it can't access $PWD *sigh*
498         (cd /tmp;
499         $RUNAS tar cf - /etc/hosts /etc/sysconfig/network | \
500         $RUNAS tar xfC - $DIR/d22)
501         ls -lR $DIR/d22/etc
502         $CHECKSTAT -t dir $DIR/d22/etc || error
503         $CHECKSTAT -u \#$RUNAS_ID $DIR/d22/etc || error
504 }
505 run_test 22 "unpack tar archive as non-root user ==============="
506
507 test_23() {
508         mkdir $DIR/d23
509         $TOEXCL $DIR/d23/f23
510         $TOEXCL -e $DIR/d23/f23 || error
511 }
512 run_test 23 "O_CREAT|O_EXCL in subdir =========================="
513
514 test_24a() {
515         echo '== rename sanity =============================================='
516         echo '-- same directory rename'
517         mkdir $DIR/R1
518         touch $DIR/R1/f
519         mv $DIR/R1/f $DIR/R1/g
520         $CHECKSTAT -t file $DIR/R1/g || error
521 }
522 run_test 24a "touch .../R1/f; rename .../R1/f .../R1/g ========="
523
524 test_24b() {
525         mkdir $DIR/R2
526         touch $DIR/R2/{f,g}
527         mv $DIR/R2/f $DIR/R2/g
528         $CHECKSTAT -a $DIR/R2/f || error
529         $CHECKSTAT -t file $DIR/R2/g || error
530 }
531 run_test 24b "touch .../R2/{f,g}; rename .../R2/f .../R2/g ====="
532
533 test_24c() {
534         mkdir $DIR/R3
535         mkdir $DIR/R3/f
536         mv $DIR/R3/f $DIR/R3/g
537         $CHECKSTAT -a $DIR/R3/f || error
538         $CHECKSTAT -t dir $DIR/R3/g || error
539 }
540 run_test 24c "mkdir .../R3/f; rename .../R3/f .../R3/g ========="
541
542 test_24d() {
543         mkdir $DIR/R4
544         mkdir $DIR/R4/{f,g}
545         perl -e "rename \"$DIR/R4/f\", \"$DIR/R4/g\";"
546         $CHECKSTAT -a $DIR/R4/f || error
547         $CHECKSTAT -t dir $DIR/R4/g || error
548 }
549 run_test 24d "mkdir .../R4/{f,g}; rename .../R4/f .../R4/g ====="
550
551 test_24e() {
552         echo '-- cross directory renames --' 
553         mkdir $DIR/R5{a,b}
554         touch $DIR/R5a/f
555         mv $DIR/R5a/f $DIR/R5b/g
556         $CHECKSTAT -a $DIR/R5a/f || error
557         $CHECKSTAT -t file $DIR/R5b/g || error
558 }
559 run_test 24e "touch .../R5a/f; rename .../R5a/f .../R5b/g ======"
560
561 test_24f() {
562         mkdir $DIR/R6{a,b}
563         touch $DIR/R6a/f $DIR/R6b/g
564         mv $DIR/R6a/f $DIR/R6b/g
565         $CHECKSTAT -a $DIR/R6a/f || error
566         $CHECKSTAT -t file $DIR/R6b/g || error
567 }
568 run_test 24f "touch .../R6a/f R6b/g; mv .../R6a/f .../R6b/g ===="
569
570 test_24g() {
571         mkdir $DIR/R7{a,b}
572         mkdir $DIR/R7a/d
573         mv $DIR/R7a/d $DIR/R7b/e
574         $CHECKSTAT -a $DIR/R7a/d || error
575         $CHECKSTAT -t dir $DIR/R7b/e || error
576 }
577 run_test 24g "mkdir .../R7a/d; rename .../R7a/d .../R5b/e ======"
578
579 test_24h() {
580         mkdir $DIR/R8{a,b}
581         mkdir $DIR/R8a/d $DIR/R8b/e
582         perl -e "rename \"$DIR/R8a/d\", \"$DIR/R8b/e\";"
583         $CHECKSTAT -a $DIR/R8a/d || error
584         $CHECKSTAT -t dir $DIR/R8b/e || error
585 }
586 run_test 24h "mkdir .../R8{a,b} R8a/{d,e}; mv .../R8a/d .../R8b/e"
587
588 test_24i() {
589         echo "-- rename error cases"
590         mkdir $DIR/R9
591         mkdir $DIR/R9/a
592         touch $DIR/R9/f
593         perl -e "rename \"$DIR/R9/f\", \"$DIR/R9/a\";"
594         $CHECKSTAT -t file $DIR/R9/f || error
595         $CHECKSTAT -t dir  $DIR/R9/a || error
596         $CHECKSTAT -a file $DIR/R9/a/f || error
597 }
598 run_test 24i "rename file to dir error: touch f ; mkdir a ; rename f a"
599
600 test_24j() {
601         mkdir $DIR/R10
602         perl -e "rename \"$DIR/R10/f\", \"$DIR/R10/g\"" 
603         $CHECKSTAT -t dir $DIR/R10 || error
604         $CHECKSTAT -a $DIR/R10/f || error
605         $CHECKSTAT -a $DIR/R10/g || error
606 }
607 run_test 24j "source does not exist ============================" 
608
609 test_24k() {
610         mkdir $DIR/R11a $DIR/R11a/d
611         touch $DIR/R11a/f
612         mv $DIR/R11a/f $DIR/R11a/d
613         $CHECKSTAT -a $DIR/R11a/f || error
614         $CHECKSTAT -t file $DIR/R11a/d/f || error
615 }
616 run_test 24k "touch .../R11a/f; mv .../R11a/f .../R11a/d ======="
617
618 # bug 2429 - rename foo foo foo creates invalid file
619 test_24l() {
620         f="$DIR/f24l"
621         multiop $f OcNs || error
622 }
623 run_test 24l "Renaming a file to itself ========================"
624
625 test_24m() {
626         f="$DIR/f24m"
627         multiop $f OcLN ${f}2 ${f}2 || error
628 }
629 run_test 24m "Renaming a file to a hard link to itself ========="
630
631 test_24n() {
632     f="$DIR/f24n"
633     # this stats the old file after it was renamed, so it should fail
634     touch ${f}
635     $CHECKSTAT ${f}
636     mv ${f} ${f}.rename
637     $CHECKSTAT ${f}.rename
638     $CHECKSTAT -a ${f}
639 }
640 run_test 24n "Statting the old file after renameing (Posix rename 2)"
641
642 test_25a() {
643         echo '== symlink sanity ============================================='
644         mkdir $DIR/d25
645         ln -s d25 $DIR/s25
646         touch $DIR/s25/foo || error
647 }
648 run_test 25a "create file in symlinked directory ==============="
649
650 test_25b() {
651         if [ ! -d $DIR/d25 ]; then
652                 run_one 25a
653         fi
654         $CHECKSTAT -t file $DIR/s25/foo || error
655 }
656 run_test 25b "lookup file in symlinked directory ==============="
657
658 test_26a() {
659         mkdir $DIR/d26
660         mkdir $DIR/d26/d26-2
661         ln -s d26/d26-2 $DIR/s26
662         touch $DIR/s26/foo || error
663 }
664 run_test 26a "multiple component symlink ======================="
665
666 test_26b() {
667         mkdir -p $DIR/d26b/d26-2
668         ln -s d26b/d26-2/foo $DIR/s26-2
669         touch $DIR/s26-2 || error
670 }
671 run_test 26b "multiple component symlink at end of lookup ======"
672
673 test_26c() {
674         mkdir $DIR/d26.2
675         touch $DIR/d26.2/foo
676         ln -s d26.2 $DIR/s26.2-1
677         ln -s s26.2-1 $DIR/s26.2-2
678         ln -s s26.2-2 $DIR/s26.2-3
679         chmod 0666 $DIR/s26.2-3/foo
680 }
681 run_test 26c "chain of symlinks ================================"
682
683 # recursive symlinks (bug 439)
684 test_26d() {
685         ln -s d26-3/foo $DIR/d26-3
686 }
687 run_test 26d "create multiple component recursive symlink ======"
688
689 test_26e() {
690         if [ ! -h $DIR/d26-3 ]; then
691                 run_one 26d
692         fi
693         rm $DIR/d26-3
694 }
695 run_test 26e "unlink multiple component recursive symlink ======"
696
697 test_27a() {
698         echo '== stripe sanity =============================================='
699         mkdir $DIR/d27
700         $LSTRIPE $DIR/d27/f0 8192 0 1 || error
701         $CHECKSTAT -t file $DIR/d27/f0 || error
702         pass
703         log "== test_27b: write to one stripe file ========================="
704         cp /etc/hosts $DIR/d27/f0 || error
705 }
706 run_test 27a "one stripe file =================================="
707
708 test_27c() {
709         [ "$STRIPECOUNT" -lt "2" ] && echo "skipping 2-stripe test" && return
710         if [ ! -d $DIR/d27 ]; then
711                 mkdir $DIR/d27
712         fi
713         $LSTRIPE $DIR/d27/f01 8192 0 2 || error
714         [ `$LFIND $DIR/d27/f01 | grep -A 10 obdidx | wc -l` -eq 4 ] ||
715                 error "two-stripe file doesn't have two stripes"
716         pass
717         log "== test_27d: write to two stripe file file f01 ================"
718         dd if=/dev/zero of=$DIR/d27/f01 bs=4k count=4 || error
719 }
720 run_test 27c "create two stripe file f01 ======================="
721
722 test_27d() {
723         if [ ! -d $DIR/d27 ]; then
724                 mkdir $DIR/d27
725         fi
726         $LSTRIPE $DIR/d27/fdef 0 -1 0 || error
727         $CHECKSTAT -t file $DIR/d27/fdef || error
728         #dd if=/dev/zero of=$DIR/d27/fdef bs=4k count=4 || error
729 }
730 run_test 27d "create file with default settings ================"
731
732 test_27e() {
733         if [ ! -d $DIR/d27 ]; then
734                 mkdir $DIR/d27
735         fi
736         $LSTRIPE $DIR/d27/f12 8192 0 2 || error
737         $LSTRIPE $DIR/d27/f12 8192 0 2 && error
738         $CHECKSTAT -t file $DIR/d27/f12 || error
739 }
740 run_test 27e "lstripe existing file (should return error) ======"
741
742 test_27f() {
743         if [ ! -d $DIR/d27 ]; then
744                 mkdir $DIR/d27
745         fi
746         $LSTRIPE $DIR/d27/fbad 100 0 1 && error
747         dd if=/dev/zero of=$DIR/d27/f12 bs=4k count=4 || error
748         $LFIND $DIR/d27/fbad || error
749 }
750 run_test 27f "lstripe with bad stripe size (should return error)"
751
752 test_27g() {
753         if [ ! -d $DIR/d27 ]; then
754                 mkdir $DIR/d27
755         fi
756         $MCREATE $DIR/d27/fnone || error
757         pass
758         log "== test 27h: lfind with no objects ============================"
759         $LFIND $DIR/d27/fnone 2>&1 | grep "no stripe info" || error
760         pass
761         log "== test 27i: lfind with some objects =========================="
762         touch $DIR/d27/fsome || error
763         $LFIND $DIR/d27/fsome | grep obdidx || error
764 }
765 run_test 27g "test lfind ======================================="
766
767 test_27j() {
768         if [ ! -d $DIR/d27 ]; then
769                 mkdir $DIR/d27
770         fi
771         $LSTRIPE $DIR/d27/f27j 8192 $STRIPECOUNT 1 && error || true
772 }
773 run_test 27j "lstripe with bad stripe offset (should return error)"
774
775 test_28() {
776         mkdir $DIR/d28
777         $CREATETEST $DIR/d28/ct || error
778 }
779 run_test 28 "create/mknod/mkdir with bad file types ============"
780
781 cancel_lru_locks() {
782         for d in /proc/fs/lustre/ldlm/namespaces/$1*; do
783                 echo clear > $d/lru_size
784         done
785         grep [0-9] /proc/fs/lustre/ldlm/namespaces/$1*/lock_unused_count /dev/null
786 }
787
788 test_29() {
789         cancel_lru_locks MDC
790         mkdir $DIR/d29
791         touch $DIR/d29/foo
792         log 'first d29'
793         ls -l $DIR/d29
794         MDCDIR=${MDCDIR:-/proc/fs/lustre/ldlm/namespaces/MDC_*}
795         LOCKCOUNTORIG=`cat $MDCDIR/lock_count`
796         LOCKUNUSEDCOUNTORIG=`cat $MDCDIR/lock_unused_count`
797         log 'second d29'
798         ls -l $DIR/d29
799         log 'done'
800         LOCKCOUNTCURRENT=`cat $MDCDIR/lock_count`
801         LOCKUNUSEDCOUNTCURRENT=`cat $MDCDIR/lock_unused_count`
802         if [ $LOCKCOUNTCURRENT -gt $LOCKCOUNTORIG ]; then
803                 echo "CURRENT: $LOCKCOUNTCURRENT > $LOCKCOUNTORIG"
804                 error
805         fi
806         if [ $LOCKUNUSEDCOUNTCURRENT -gt $LOCKUNUSEDCOUNTORIG ]; then
807                 echo "UNUSED: $LOCKUNUSEDCOUNTCURRENT > $LOCKUNUSEDCOUNTORIG"
808                 error
809         fi
810 }
811 run_test 29 "IT_GETATTR regression  ============================"
812
813 test_30() {
814         cp `which ls` $DIR
815         $DIR/ls /
816         rm $DIR/ls
817 }
818 run_test 30 "run binary from Lustre (execve) ==================="
819
820 test_31a() {
821         $OPENUNLINK $DIR/f31 $DIR/f31 || error
822         $CHECKSTAT -a $DIR/f31 || error
823 }
824 run_test 31a "open-unlink file =================================="
825
826 test_31b() {
827         touch $DIR/f31 || error
828         ln $DIR/f31 $DIR/f31b || error
829         multiop $DIR/f31b Ouc || error
830         $CHECKSTAT -t file $DIR/f31 || error
831 }
832 run_test 31b "unlink file with multiple links while open ======="
833
834 test_31c() {
835         touch $DIR/f31 || error
836         ln $DIR/f31 $DIR/f31c || error
837         multiop $DIR/f31 O_uc &
838         MULTIPID=$!
839         multiop $DIR/f31c Ouc
840         usleep 500
841         kill -USR1 $MULTIPID
842         wait $MUTLIPID
843 }
844 run_test 31c "open-unlink file with multiple links ============="
845
846 test_31d() {
847         opendirunlink $DIR/d31d $DIR/d31d || error
848         $CHECKSTAT -a $DIR/d31d || error
849 }
850 run_test 31d "remove of open directory ========================="
851
852 test_32a() {
853         echo "== more mountpoints and symlinks ================="
854         [ -e $DIR/d32a ] && rm -fr $DIR/d32a
855         mkdir -p $DIR/d32a/ext2-mountpoint 
856         mount -t ext2 -o loop $EXT2_DEV $DIR/d32a/ext2-mountpoint || error
857         $CHECKSTAT -t dir $DIR/d32a/ext2-mountpoint/.. || error  
858         umount $DIR/d32a/ext2-mountpoint || error
859 }
860 run_test 32a "stat d32a/ext2-mountpoint/.. ====================="
861
862 test_32b() {
863         [ -e $DIR/d32b ] && rm -fr $DIR/d32b
864         mkdir -p $DIR/d32b/ext2-mountpoint 
865         mount -t ext2 -o loop $EXT2_DEV $DIR/d32b/ext2-mountpoint || error
866         ls -al $DIR/d32b/ext2-mountpoint/.. || error
867         umount $DIR/d32b/ext2-mountpoint || error
868 }
869 run_test 32b "open d32b/ext2-mountpoint/.. ====================="
870  
871 test_32c() {
872         [ -e $DIR/d32c ] && rm -fr $DIR/d32c
873         mkdir -p $DIR/d32c/ext2-mountpoint 
874         mount -t ext2 -o loop $EXT2_DEV $DIR/d32c/ext2-mountpoint || error
875         mkdir -p $DIR/d32c/d2/test_dir    
876         $CHECKSTAT -t dir $DIR/d32c/ext2-mountpoint/../d2/test_dir || error
877         umount $DIR/d32c/ext2-mountpoint || error
878 }
879 run_test 32c "stat d32c/ext2-mountpoint/../d2/test_dir ========="
880
881 test_32d() {
882         [ -e $DIR/d32d ] && rm -fr $DIR/d32d
883         mkdir -p $DIR/d32d/ext2-mountpoint 
884         mount -t ext2 -o loop $EXT2_DEV $DIR/d32d/ext2-mountpoint || error
885         mkdir -p $DIR/d32d/d2/test_dir    
886         ls -al $DIR/d32d/ext2-mountpoint/../d2/test_dir || error
887         umount $DIR/d32d/ext2-mountpoint || error
888 }
889 run_test 32d "open d32d/ext2-mountpoint/../d2/test_dir ========="
890
891 test_32e() {
892         [ -e $DIR/d32e ] && rm -fr $DIR/d32e
893         mkdir -p $DIR/d32e/tmp    
894         TMP_DIR=$DIR/d32e/tmp       
895         ln -s $DIR/d32e $TMP_DIR/symlink11 
896         ln -s $TMP_DIR/symlink11 $TMP_DIR/../symlink01 
897         $CHECKSTAT -t link $DIR/d32e/tmp/symlink11 || error
898         $CHECKSTAT -t link $DIR/d32e/symlink01 || error
899 }
900 run_test 32e "stat d32e/symlink->tmp/symlink->lustre-subdir ===="
901
902 test_32f() {
903         [ -e $DIR/d32f ] && rm -fr $DIR/d32f
904         mkdir -p $DIR/d32f/tmp    
905         TMP_DIR=$DIR/d32f/tmp       
906         ln -s $DIR/d32f $TMP_DIR/symlink11 
907         ln -s $TMP_DIR/symlink11 $TMP_DIR/../symlink01 
908         ls $DIR/d32f/tmp/symlink11  || error
909         ls $DIR/d32f/symlink01 || error
910 }
911 run_test 32f "open d32f/symlink->tmp/symlink->lustre-subdir ===="
912
913 test_32g() {
914         [ -e $DIR/d32g ] && rm -fr $DIR/d32g
915         [ -e $DIR/test_dir ] && rm -fr $DIR/test_dir
916         mkdir -p $DIR/test_dir 
917         mkdir -p $DIR/d32g/tmp    
918         TMP_DIR=$DIR/d32g/tmp       
919         ln -s $DIR/test_dir $TMP_DIR/symlink12 
920         ln -s $TMP_DIR/symlink12 $TMP_DIR/../symlink02 
921         $CHECKSTAT -t link $DIR/d32g/tmp/symlink12 || error
922         $CHECKSTAT -t link $DIR/d32g/symlink02 || error
923         $CHECKSTAT -t dir -f $DIR/d32g/tmp/symlink12 || error
924         $CHECKSTAT -t dir -f $DIR/d32g/symlink02 || error
925 }
926 run_test 32g "stat d32g/symlink->tmp/symlink->lustre-subdir/test_dir"
927
928 test_32h() {
929         [ -e $DIR/d32h ] && rm -fr $DIR/d32h
930         [ -e $DIR/test_dir ] && rm -fr $DIR/test_dir
931         mkdir -p $DIR/test_dir 
932         mkdir -p $DIR/d32h/tmp    
933         TMP_DIR=$DIR/d32h/tmp       
934         ln -s $DIR/test_dir $TMP_DIR/symlink12 
935         ln -s $TMP_DIR/symlink12 $TMP_DIR/../symlink02 
936         ls $DIR/d32h/tmp/symlink12 || error
937         ls $DIR/d32h/symlink02  || error
938 }
939 run_test 32h "open d32h/symlink->tmp/symlink->lustre-subdir/test_dir"
940
941 test_32i() {
942         [ -e $DIR/d32i ] && rm -fr $DIR/d32i
943         mkdir -p $DIR/d32i/ext2-mountpoint 
944         mount -t ext2 -o loop $EXT2_DEV $DIR/d32i/ext2-mountpoint || error
945         touch $DIR/d32i/test_file
946         $CHECKSTAT -t file $DIR/d32i/ext2-mountpoint/../test_file || error  
947         umount $DIR/d32i/ext2-mountpoint || error
948 }
949 run_test 32i "stat d32i/ext2-mountpoint/../test_file ==========="
950
951 test_32j() {
952         [ -e $DIR/d32j ] && rm -fr $DIR/d32j
953         mkdir -p $DIR/d32j/ext2-mountpoint 
954         mount -t ext2 -o loop $EXT2_DEV $DIR/d32j/ext2-mountpoint || error
955         touch $DIR/d32j/test_file
956         cat $DIR/d32j/ext2-mountpoint/../test_file || error
957         umount $DIR/d32j/ext2-mountpoint || error
958 }
959 run_test 32j "open d32j/ext2-mountpoint/../test_file ==========="
960
961 test_32k() {
962         rm -fr $DIR/d32k
963         mkdir -p $DIR/d32k/ext2-mountpoint 
964         mount -t ext2 -o loop $EXT2_DEV $DIR/d32k/ext2-mountpoint  
965         mkdir -p $DIR/d32k/d2
966         touch $DIR/d32k/d2/test_file || error
967         $CHECKSTAT -t file $DIR/d32k/ext2-mountpoint/../d2/test_file || error
968         umount $DIR/d32k/ext2-mountpoint || error
969 }
970 run_test 32k "stat d32k/ext2-mountpoint/../d2/test_file ========"
971
972 test_32l() {
973         rm -fr $DIR/d32l
974         mkdir -p $DIR/d32l/ext2-mountpoint 
975         mount -t ext2 -o loop $EXT2_DEV $DIR/d32l/ext2-mountpoint || error
976         mkdir -p $DIR/d32l/d2
977         touch $DIR/d32l/d2/test_file
978         cat  $DIR/d32l/ext2-mountpoint/../d2/test_file || error
979         umount $DIR/d32l/ext2-mountpoint || error
980 }
981 run_test 32l "open d32l/ext2-mountpoint/../d2/test_file ========"
982
983 test_32m() {
984         rm -fr $DIR/d32m
985         mkdir -p $DIR/d32m/tmp    
986         TMP_DIR=$DIR/d32m/tmp       
987         ln -s $DIR $TMP_DIR/symlink11 
988         ln -s $TMP_DIR/symlink11 $TMP_DIR/../symlink01 
989         $CHECKSTAT -t link $DIR/d32m/tmp/symlink11 || error
990         $CHECKSTAT -t link $DIR/d32m/symlink01 || error
991 }
992 run_test 32m "stat d32m/symlink->tmp/symlink->lustre-root ======"
993
994 test_32n() {
995         rm -fr $DIR/d32n
996         mkdir -p $DIR/d32n/tmp    
997         TMP_DIR=$DIR/d32n/tmp       
998         ln -s $DIR $TMP_DIR/symlink11 
999         ln -s $TMP_DIR/symlink11 $TMP_DIR/../symlink01 
1000         ls -l $DIR/d32n/tmp/symlink11  || error
1001         ls -l $DIR/d32n/symlink01 || error
1002 }
1003 run_test 32n "open d32n/symlink->tmp/symlink->lustre-root ======"
1004
1005 test_32o() {
1006         rm -fr $DIR/d32o
1007         rm -f $DIR/test_file
1008         touch $DIR/test_file 
1009         mkdir -p $DIR/d32o/tmp    
1010         TMP_DIR=$DIR/d32o/tmp       
1011         ln -s $DIR/test_file $TMP_DIR/symlink12 
1012         ln -s $TMP_DIR/symlink12 $TMP_DIR/../symlink02 
1013         $CHECKSTAT -t link $DIR/d32o/tmp/symlink12 || error
1014         $CHECKSTAT -t link $DIR/d32o/symlink02 || error
1015         $CHECKSTAT -t file -f $DIR/d32o/tmp/symlink12 || error
1016         $CHECKSTAT -t file -f $DIR/d32o/symlink02 || error
1017 }
1018 run_test 32o "stat d32o/symlink->tmp/symlink->lustre-root/test_file"
1019
1020 test_32p() {
1021     log 32p_1
1022         rm -fr $DIR/d32p
1023     log 32p_2
1024         rm -f $DIR/test_file
1025     log 32p_3
1026         touch $DIR/test_file 
1027     log 32p_4
1028         mkdir -p $DIR/d32p/tmp    
1029     log 32p_5
1030         TMP_DIR=$DIR/d32p/tmp       
1031     log 32p_6
1032         ln -s $DIR/test_file $TMP_DIR/symlink12 
1033     log 32p_7
1034         ln -s $TMP_DIR/symlink12 $TMP_DIR/../symlink02 
1035     log 32p_8
1036         cat $DIR/d32p/tmp/symlink12 || error
1037     log 32p_9
1038         cat $DIR/d32p/symlink02 || error
1039     log 32p_10
1040 }
1041 run_test 32p "open d32p/symlink->tmp/symlink->lustre-root/test_file"
1042
1043 test_32q() {
1044         [ -e $DIR/d32q ] && rm -fr $DIR/d32q
1045         mkdir -p $DIR/d32q
1046         touch $DIR/d32q/under_the_mount
1047         mount -t ext2 -o loop $EXT2_DEV $DIR/d32q
1048         ls $DIR/d32q/under_the_mount && error || true
1049         umount $DIR/d32q || error
1050 }
1051 run_test 32q "stat follows mountpoints in Lustre (should return error)"
1052
1053 test_32r() {
1054         [ -e $DIR/d32r ] && rm -fr $DIR/d32r
1055         mkdir -p $DIR/d32r
1056         touch $DIR/d32r/under_the_mount
1057         mount -t ext2 -o loop $EXT2_DEV $DIR/d32r
1058         ls $DIR/d32r | grep -q under_the_mount && error || true
1059         umount $DIR/d32r || error
1060 }
1061 run_test 32r "opendir follows mountpoints in Lustre (should return error)"
1062
1063 #   chmod 444 /mnt/lustre/somefile
1064 #   open(/mnt/lustre/somefile, O_RDWR)
1065 #   Should return -1
1066 test_33() {
1067         rm -f $DIR/test_33_file
1068         touch $DIR/test_33_file
1069         chmod 444 $DIR/test_33_file
1070         chown $RUNAS_ID $DIR/test_33_file
1071         log 33_1
1072         $RUNAS $OPENFILE -f O_RDWR $DIR/test_33_file && error || true
1073         log 33_2
1074 }
1075 run_test 33 "write file with mode 444 (should return error) ===="
1076                                                                                                                                                
1077 test_33a() {
1078         rm -fr $DIR/d33
1079         mkdir -p $DIR/d33
1080         chown $RUNAS_ID $DIR/d33
1081         $RUNAS $OPENFILE -f O_RDWR:O_CREAT -m 0444 $DIR/d33/f33 || error
1082         $RUNAS $OPENFILE -f O_RDWR:O_CREAT -m 0444 $DIR/d33/f33 && error || true
1083 }
1084 run_test 33a "test open file(mode=0444) with O_RDWR (should return error) ===="
1085
1086 TEST_34_SIZE=${TEST_34_SIZE:-2000000000000}
1087 test_34a() {
1088         rm -f $DIR/test_34_file
1089         $MCREATE $DIR/test_34_file || error
1090         $LFIND $DIR/test_34_file 2>&1 | grep -q "no stripe info" || error
1091         $TRUNCATE $DIR/test_34_file $TEST_34_SIZE || error
1092         $LFIND $DIR/test_34_file 2>&1 | grep -q "no stripe info" || error
1093         $CHECKSTAT -s $TEST_34_SIZE $DIR/test_34_file || error
1094 }
1095 run_test 34a "truncate file that has not been opened ==========="
1096
1097 test_34b() {
1098         [ ! -f $DIR/test_34_file ] && run_one 34a
1099         $CHECKSTAT -s $TEST_34_SIZE $DIR/test_34_file || error
1100         $OPENFILE -f O_RDONLY $DIR/test_34_file
1101         $LFIND $DIR/test_34_file 2>&1 | grep -q "no stripe info" || error
1102         $CHECKSTAT -s $TEST_34_SIZE $DIR/test_34_file || error
1103 }
1104 run_test 34b "O_RDONLY opening file doesn't create objects ====="
1105
1106 test_34c() {
1107         [ ! -f $DIR/test_34_file ] && run_one 34a 
1108         $CHECKSTAT -s $TEST_34_SIZE $DIR/test_34_file || error
1109         $OPENFILE -f O_RDWR $DIR/test_34_file
1110         $LFIND $DIR/test_34_file 2>&1 | grep -q "no stripe info" && error
1111         $CHECKSTAT -s $TEST_34_SIZE $DIR/test_34_file || error
1112 }
1113 run_test 34c "O_RDWR opening file-with-size works =============="
1114
1115 test_34d() {
1116         dd if=/dev/zero of=$DIR/test_34_file conv=notrunc bs=4k count=1 || error
1117         $CHECKSTAT -s $TEST_34_SIZE $DIR/test_34_file || error
1118         rm $DIR/test_34_file
1119 }
1120 run_test 34d "write to sparse file ============================="
1121
1122 test_34e() {
1123         rm -f $DIR/test_34_file
1124         $MCREATE $DIR/test_34_file || error
1125         $TRUNCATE $DIR/test_34_file 1000 || error
1126         $CHECKSTAT -s 1000 $DIR/test_34_file || error
1127         $OPENFILE -f O_RDWR $DIR/test_34_file
1128         $CHECKSTAT -s 1000 $DIR/test_34_file || error
1129 }
1130 run_test 34e "create objects, some with size and some without =="
1131
1132 test_35a() {
1133         cp /bin/sh $DIR/test_35a_file
1134         chmod 444 $DIR/test_35a_file
1135         chown $RUNAS_ID $DIR/test_35a_file
1136         $RUNAS $DIR/test_35a_file && error || true
1137         rm $DIR/test_35a_file
1138 }
1139 run_test 35a "exec file with mode 444 (should return and not leak) ====="
1140
1141
1142 test_36a() {
1143         rm -f $DIR/test_36_file
1144         utime $DIR/test_36_file || error
1145 }
1146 run_test 36a "MDS utime check (mknod, utime) ==================="
1147
1148 test_36b() {
1149         echo "" > $DIR/test_36_file
1150         utime $DIR/test_36_file || error
1151 }
1152 run_test 36b "OST utime check (open, utime) ===================="
1153
1154 test_36c() {
1155         rm -f $DIR/d36/test_36_file
1156         mkdir $DIR/d36
1157         chown $RUNAS_ID $DIR/d36
1158         $RUNAS utime $DIR/d36/test_36_file || error
1159 }
1160 run_test 36c "non-root MDS utime check (mknod, utime) =========="
1161
1162 test_36d() {
1163         [ ! -d $DIR/d36 ] && run_one 36c
1164         echo "" > $DIR/d36/test_36_file
1165         $RUNAS utime $DIR/d36/test_36_file || error
1166 }
1167 run_test 36d "non-root OST utime check (open, utime) ==========="
1168
1169 test_36e() {
1170         [ $RUNAS_ID -eq $UID ] && return
1171         [ ! -d $DIR/d36 ] && mkdir $DIR/d36
1172         touch $DIR/d36/test_36_file2
1173         $RUNAS utime $DIR/d36/test_36_file2 && error || true
1174 }
1175 run_test 36e "utime on non-owned file (should return error) ===="
1176
1177 test_37() {
1178         mkdir -p $DIR/dextra
1179         echo f > $DIR/dextra/fbugfile
1180         mount -t ext2 -o loop $EXT2_DEV $DIR/dextra
1181         ls $DIR/dextra | grep "\<fbugfile\>" && error
1182         umount $DIR/dextra || error
1183         rm -f $DIR/dextra/fbugfile || error
1184 }
1185 run_test 37 "ls a mounted file system to check old content ====="
1186
1187 test_38() {
1188         o_directory $DIR/test38
1189 }
1190 run_test 38 "open a regular file with O_DIRECTORY =============="
1191
1192 test_39() {
1193         touch $DIR/test_39_file
1194         touch $DIR/test_39_file2
1195 #       ls -l  $DIR/test_39_file $DIR/test_39_file2
1196 #       ls -lu  $DIR/test_39_file $DIR/test_39_file2
1197 #       ls -lc  $DIR/test_39_file $DIR/test_39_file2
1198         sleep 2
1199         $OPENFILE -f O_CREAT:O_TRUNC:O_WRONLY $DIR/test_39_file2
1200 #       ls -l  $DIR/test_39_file $DIR/test_39_file2
1201 #       ls -lu  $DIR/test_39_file $DIR/test_39_file2
1202 #       ls -lc  $DIR/test_39_file $DIR/test_39_file2
1203         [ $DIR/test_39_file2 -nt $DIR/test_39_file ] || error
1204 }
1205 run_test 39 "mtime changed on create ==========================="
1206
1207 test_40() {
1208         dd if=/dev/zero of=$DIR/f40 bs=4096 count=1
1209         $RUNAS $OPENFILE -f O_WRONLY:O_TRUNC $DIR/f40 && error
1210         $CHECKSTAT -t file -s 4096 $DIR/f40 || error
1211 }
1212 run_test 40 "failed open(O_TRUNC) doesn't truncate ============="
1213
1214 test_41() {
1215         # bug 1553
1216         small_write $DIR/f41 18
1217 }
1218 run_test 41 "test small file write + fstat ====================="
1219
1220 count_ost_writes() {
1221         cat /proc/fs/lustre/osc/*/stats |
1222             awk -vwrites=0 '/ost_write/ { writes += $2 } END { print writes; }'
1223 }
1224 start_kupdated() {
1225         # in 2.6, restore /proc/sys/vm/dirty_writeback_centisecs
1226         kill -CONT `pidof kupdated`
1227 }
1228 stop_kupdated() {
1229         # in 2.6, save and 0 /proc/sys/vm/dirty_writeback_centisecs
1230         kill -STOP `pidof kupdated`
1231         trap start_kupdated EXIT
1232 }
1233
1234 # Tests 42* verify that our behaviour is correct WRT caching, file closure,
1235 # file truncation, and file removal.
1236 test_42a() {
1237         cancel_lru_locks OSC
1238         stop_kupdated
1239         sync # just to be safe
1240         BEFOREWRITES=`count_ost_writes`
1241         dd if=/dev/zero of=$DIR/f42a bs=1024 count=100
1242         AFTERWRITES=`count_ost_writes`
1243         [ $BEFOREWRITES -eq $AFTERWRITES ] || \
1244                 error "$BEFOREWRITES < $AFTERWRITES"
1245         start_kupdated
1246 }
1247 run_test 42a "ensure that we don't flush on close =============="
1248
1249 test_42b() {
1250         cancel_lru_locks OSC
1251         stop_kupdated
1252         sync
1253         dd if=/dev/zero of=$DIR/f42b bs=1024 count=100
1254         BEFOREWRITES=`count_ost_writes`
1255         $MUNLINK $DIR/f42b || error "$MUNLINK $DIR/f42b: $?"
1256         AFTERWRITES=`count_ost_writes`
1257         [ $BEFOREWRITES -eq $AFTERWRITES ] ||
1258             error "$BEFOREWRITES < $AFTERWRITES on unlink"
1259         BEFOREWRITES=`count_ost_writes`
1260         sync || error "sync: $?"
1261         AFTERWRITES=`count_ost_writes`
1262         [ $BEFOREWRITES -eq $AFTERWRITES ] ||
1263             error "$BEFOREWRITES < $AFTERWRITES on sync"
1264         dmesg | grep 'error from obd_brw_async' && error 'error writing back'
1265         start_kupdated
1266         return 0
1267 }
1268 run_test 42b "test destroy of file with cached dirty data ======"
1269
1270 # if these tests just want to test the effect of truncation,
1271 # they have to be very careful.  consider:
1272 # - the first open gets a {0,EOF}PR lock
1273 # - the first write conflicts and gets a {0, count-1}PW
1274 # - the rest of the writes are under {count,EOF}PW
1275 # - the open for truncate tries to match a {0,EOF}PR
1276 #   for the filesize and cancels the PWs.
1277 # any number of fixes (don't get {0,EOF} on open, match
1278 # composite locks, do smarter file size management) fix
1279 # this, but for now we want these tests to verify that
1280 # the cancelation with truncate intent works, so we
1281 # start the file with a full-file pw lock to match against
1282 # until the truncate.
1283 trunc_test() {
1284         test=$1
1285         file=$DIR/$test
1286         offset=$2
1287         cancel_lru_locks OSC
1288         stop_kupdated
1289         # prime the file with 0,EOF PW to match
1290         touch $file
1291         $TRUNCATE $file 0
1292         sync; sync
1293         # now the real test..
1294         dd if=/dev/zero of=$file bs=1024 count=100
1295         BEFOREWRITES=`count_ost_writes`
1296         $TRUNCATE $file $offset
1297         cancel_lru_locks OSC
1298         AFTERWRITES=`count_ost_writes`
1299         start_kupdated
1300 }
1301
1302 test_42c() {
1303         trunc_test 42c 1024
1304         [ $BEFOREWRITES -eq $AFTERWRITES ] && \
1305             error "$BEFOREWRITES < $AFTERWRITES on truncate"
1306         rm $file
1307 }
1308 run_test 42c "test partial truncate of file with cached dirty data ===="
1309
1310 test_42d() {
1311         trunc_test 42d 0
1312         [ $BEFOREWRITES -eq $AFTERWRITES ] || \
1313             error "beforewrites $BEFOREWRITES != afterwrites $AFTERWRITES on truncate"
1314         rm $file
1315 }
1316 run_test 42d "test complete truncate of file with cached dirty data ===="
1317
1318 test_43() {
1319         mkdir $DIR/d43
1320         cp -p /bin/ls $DIR/d43/f
1321         exec 100>> $DIR/d43/f   
1322         $DIR/d43/f && error || true
1323         exec 100<&-
1324 }
1325 run_test 43 "execution of file opened for write should return -ETXTBSY=="
1326
1327 test_43a() {
1328         mkdir -p $DIR/d43
1329         cp -p `which multiop` $DIR/d43/multiop
1330         touch $DIR/d43/g
1331         $DIR/d43/multiop $DIR/d43/g o_c &
1332         MULTIPID=$!
1333         sleep 1
1334         multiop $DIR/d43/multiop Oc && error "expected error, got success"
1335         kill -USR1 $MULTIPID || return 2
1336         wait $MULTIPID || return 3
1337 }
1338 run_test 43a "open(RDWR) of file being executed should return -ETXTBSY=="
1339
1340 test_43b() {
1341         mkdir -p $DIR/d43
1342         cp -p `which multiop` $DIR/d43/multiop
1343         touch $DIR/d43/g
1344         $DIR/d43/multiop $DIR/d43/g o_c &
1345         MULTIPID=$!
1346         sleep 1
1347         truncate $DIR/d43/multiop 0 && error "expected error, got success"
1348         kill -USR1 $MULTIPID || return 2
1349         wait $MULTIPID || return 3
1350 }
1351 run_test 43b "truncate of file being executed should return -ETXTBSY===="
1352
1353 test_43c() {
1354         local testdir="$DIR/d43c"
1355         mkdir -p $testdir
1356         cp $SHELL $testdir/
1357         ( cd $(dirname $SHELL) && md5sum $(basename $SHELL) ) |  \
1358                 ( cd $testdir && md5sum -c)
1359 }
1360 run_test 43c "md5sum of copy into lustre================================"
1361
1362 test_44() {
1363         [  "$STRIPECOUNT" -lt "2" ] && echo "skipping 2-stripe test" && return
1364         dd if=/dev/zero of=$DIR/f1 bs=4k count=1 seek=127
1365         dd if=$DIR/f1 bs=4k count=1
1366 }
1367 run_test 44 "zero length read from a sparse stripe ============="
1368
1369 test_44a() {
1370     local nstripe=`$LCTL lov_getconfig $DIR | grep default_stripe_count: | \
1371                          awk '{print $2}'`
1372     local stride=`$LCTL lov_getconfig $DIR | grep default_stripe_size: | \
1373                       awk '{print $2}'`
1374     if [ $nstripe -eq 0 ] ; then
1375         nstripe=`$LCTL lov_getconfig $DIR | grep obd_count: | awk '{print $2}'`
1376     fi
1377
1378     OFFSETS="0 $((stride/2)) $((stride-1))"
1379     for offset in $OFFSETS ; do
1380       for i in `seq 0 $((nstripe-1))`; do
1381         rm -f $DIR/d44a
1382         local GLOBALOFFSETS=""
1383         local size=$((((i + 2 * $nstripe )*$stride + $offset)))  # Bytes
1384         ll_sparseness_write $DIR/d44a $size  || error "ll_sparseness_write"
1385         GLOBALOFFSETS="$GLOBALOFFSETS $size"
1386         ll_sparseness_verify $DIR/d44a $GLOBALOFFSETS \
1387                             || error "ll_sparseness_verify $GLOBALOFFSETS"
1388
1389         for j in `seq 0 $((nstripe-1))`; do
1390             size=$((((j + $nstripe )*$stride + $offset)))  # Bytes
1391             ll_sparseness_write $DIR/d44a $size || error "ll_sparseness_write"
1392             GLOBALOFFSETS="$GLOBALOFFSETS $size"
1393         done
1394         ll_sparseness_verify $DIR/d44a $GLOBALOFFSETS \
1395                             || error "ll_sparseness_verify $GLOBALOFFSETS"
1396       done
1397     done
1398 }
1399 run_test 44a "test sparse pwrite ==============================="
1400
1401 dirty_osc_total() {
1402         tot=0
1403         for d in /proc/fs/lustre/osc/*/cur_dirty_bytes; do
1404                 tot=$(($tot + `cat $d`))
1405         done
1406         echo $tot
1407 }
1408 do_dirty_record() {
1409         before=`dirty_osc_total`
1410         echo executing "\"$*\""
1411         eval $*
1412         after=`dirty_osc_total`
1413         echo before $before, after $after
1414 }
1415 test_45() {
1416         f="$DIR/f45"
1417         stop_kupdated
1418         sync
1419         do_dirty_record "echo blah > $f"
1420         [ $before -eq $after ] && error "write wasn't cached"
1421         do_dirty_record "> $f"
1422         [ $before -gt $after ] || error "truncate didn't lower dirty count"
1423         do_dirty_record "echo blah > $f"
1424         [ $before -eq $after ] && error "write wasn't cached"
1425         do_dirty_record "sync"
1426         [ $before -gt $after ] || error "writeback didn't lower dirty count"
1427         do_dirty_record "echo blah > $f"
1428         [ $before -eq $after ] && error "write wasn't cached"
1429         do_dirty_record "cancel_lru_locks OSC"
1430         [ $before -gt $after ] || error "lock cancelation didn't lower dirty count"
1431         start_kupdated
1432 }
1433 run_test 45 "osc io page accounting ============================"
1434
1435 page_size() {
1436         getconf PAGE_SIZE
1437 }
1438
1439 # in a 2 stripe file (lov.sh), page 63 maps to page 31 in its object.  this
1440 # test tickles a bug where re-dirtying a page was failing to be mapped to the
1441 # objects offset and an assert hit when an rpc was built with 63's mapped 
1442 # offset 31 and 31's raw 31 offset. it also found general redirtying bugs.
1443 test_46() {
1444         f="$DIR/f46"
1445         stop_kupdated
1446         sync
1447         dd if=/dev/zero of=$f bs=`page_size` seek=31 count=1
1448         sync
1449         dd conv=notrunc if=/dev/zero of=$f bs=`page_size` seek=63 count=1
1450         dd conv=notrunc if=/dev/zero of=$f bs=`page_size` seek=31 count=1
1451         sync
1452         start_kupdated
1453 }
1454 run_test 46 "dirtying a previously written page ================"
1455
1456 # Check that device nodes are created and then visible correctly (#2091)
1457 test_47() {
1458         cmknod $DIR/test_47_node || error
1459 }
1460 run_test 47 "Device nodes check ================================"
1461
1462 test_48() {
1463         mkdir $DIR/d48
1464         cd $DIR/d48
1465         mv $DIR/d48 $DIR/d48.new || error "move directory failed"
1466         mkdir $DIR/d48 || error "recreate diectory failed"
1467         ls || error "can't list after recreate directory"
1468 }
1469 run_test 48 "Access renamed current working directory ========="
1470
1471 test_50() {
1472         # bug 1485
1473         mkdir $DIR/d50
1474         cd $DIR/d50
1475         ls /proc/$$/cwd || error
1476 }
1477 run_test 50 "special situations: /proc symlinks  ==============="
1478
1479 test_51() {
1480         # bug 1516 - create an empty entry right after ".." then split dir
1481         mkdir $DIR/d49
1482         touch $DIR/d49/foo
1483         $MCREATE $DIR/d49/bar
1484         rm $DIR/d49/foo
1485         createmany -m $DIR/d49/longfile 201
1486         FNUM=202
1487         while [ `ls -sd $DIR/d49 | awk '{ print $1 }'` -eq 4 ]; do
1488                 $MCREATE $DIR/d49/longfile$FNUM
1489                 FNUM=$(($FNUM + 1))
1490                 echo -n "+"
1491         done
1492         ls -l $DIR/d49 > /dev/null || error
1493 }
1494 run_test 51 "special situations: split htree with empty entry =="
1495
1496 test_52a() {
1497         [ -f $DIR/d52a/foo ] && chattr -a $DIR/d52a/foo
1498         mkdir -p $DIR/d52a
1499         touch $DIR/d52a/foo
1500         chattr =a $DIR/d52a/foo || error
1501         echo bar >> $DIR/d52a/foo || error
1502         cp /etc/hosts $DIR/d52a/foo && error
1503         rm -f $DIR/d52a/foo 2>/dev/null && error
1504         link $DIR/d52a/foo $DIR/d52a/foo_link 2>/dev/null && error
1505         echo foo >> $DIR/d52a/foo || error
1506         mrename $DIR/d52a/foo $DIR/d52a/foo_ren && error
1507         lsattr $DIR/d52a/foo | egrep -q "^-+a-+ $DIR/d52a/foo" || error
1508         chattr -a $DIR/d52a/foo || error
1509
1510         rm -fr $DIR/d52a || error
1511 }
1512 run_test 52a "append-only flag test (should return errors) ====="
1513
1514 test_52b() {
1515         [ -f $DIR/d52b/foo ] && chattr -i $DIR/d52b/foo
1516         mkdir -p $DIR/d52b
1517         touch $DIR/d52b/foo
1518         chattr =i $DIR/d52b/foo || error
1519         cat test > $DIR/d52b/foo && error
1520         cp /etc/hosts $DIR/d52b/foo && error
1521         rm -f $DIR/d52b/foo 2>/dev/null && error
1522         link $DIR/d52b/foo $DIR/d52b/foo_link 2>/dev/null && error
1523         echo foo >> $DIR/d52b/foo && error
1524         mrename $DIR/d52b/foo $DIR/d52b/foo_ren && error
1525         [ -f $DIR/d52b/foo ] || error
1526         [ -f $DIR/d52b/foo_ren ] && error
1527         lsattr $DIR/d52b/foo | egrep -q "^-+i-+ $DIR/d52b/foo" || error
1528         chattr -i $DIR/d52b/foo || error
1529
1530         rm -fr $DIR/d52b || error
1531 }
1532 run_test 52b "immutable flag test (should return errors) ======="
1533
1534 test_53() {
1535         for i in `ls -d /proc/fs/lustre/osc/OSC*mds1 2> /dev/null` ; do
1536                 ostname=`echo $i | cut -d _ -f 3-4 | sed -e s/_mds1//`
1537                 ost_last=`cat /proc/fs/lustre/obdfilter/$ostname/last_id`
1538                 mds_last=`cat $i/prealloc_last_id`
1539                 echo "$ostname.last_id=$ost_last ; MDS.last_id=$mds_last"
1540                 if [ $ost_last != $mds_last ]; then
1541                     error "$ostname.last_id=$ost_last ; MDS.last_id=$mds_last"
1542                 fi
1543         done
1544 }
1545 run_test 53 "verify that MDS and OSTs agree on pre-creation ===="
1546
1547 test_54() {
1548         $SOCKETSERVER $DIR/socket &
1549         sleep 1
1550         $SOCKETCLIENT $DIR/socket || error
1551         $MUNLINK $DIR/socket
1552 }
1553 run_test 54 "unix damain socket test ==========================="
1554
1555 test_55() {
1556         rm -rf $DIR/d55
1557         mkdir $DIR/d55
1558         mount -t ext3 -o loop,iopen $EXT3_DEV $DIR/d55 || error
1559         touch $DIR/d55/foo
1560         $IOPENTEST1 $DIR/d55/foo $DIR/d55 || error
1561         $IOPENTEST2 $DIR/d55 || error
1562         echo "check for $EXT3_DEV. Please wait..."
1563         rm -rf $DIR/d55/*
1564         umount $DIR/d55 || error
1565 }
1566 run_test 55 "check iopen_connect_dentry()======================="
1567
1568 test_56() {
1569         rm -rf $DIR/d56
1570         mkdir $DIR/d56
1571         mkdir $DIR/d56/dir
1572         NUMFILES=3
1573         NUMFILESx2=$(($NUMFILES * 2))
1574         for i in `seq 1 $NUMFILES` ; do
1575                 touch $DIR/d56/file$i
1576                 touch $DIR/d56/dir/file$i
1577         done
1578
1579         # test lfs find with --recursive
1580         FILENUM=`$LFIND --recursive $DIR/d56 | grep -c obdidx`
1581         [ $FILENUM -eq $NUMFILESx2 ] || error \
1582                 "lfs find --recursive $DIR/d56 wrong: found $FILENUM, expected $NUMFILESx2"
1583         FILENUM=`$LFIND $DIR/d56 | grep -c obdidx`
1584         [ $FILENUM -eq $NUMFILES ] || error \
1585                 "lfs find $DIR/d56 without --recursive wrong: found $FILENUM,
1586                 expected $NUMFILES"
1587         echo "lfs find --recursive passed."
1588
1589         # test lfs find with file instead of dir
1590         FILENUM=`$LFIND $DIR/d56/file1 | grep -c obdidx`
1591         [ $FILENUM  -eq 1 ] || error \
1592                  "lfs find $DIR/d56/file1 wrong:found $FILENUM, expected 1"
1593         echo "lfs find file passed."
1594
1595         #test lfs find with --verbose
1596         [ `$LFIND --verbose $DIR/d56 | grep -c lmm_magic` -eq $NUMFILES ] ||\
1597                 error "lfs find --verbose $DIR/d56 wrong: should find $NUMFILES lmm_magic info"
1598         [ `$LFIND $DIR/d56 | grep -c lmm_magic` -eq 0 ] || error \
1599                 "lfs find $DIR/d56 without --verbose wrong: should not show lmm_magic info"
1600         echo "lfs find --verbose passed."
1601
1602         #test lfs find with --obd
1603         $LFIND --obd wrong_uuid $DIR/d56 2>&1 | grep -q "unknown obduuid" || \
1604                 error "lfs find --obd wrong_uuid should return error information"
1605
1606         [  "$STRIPECOUNT" -lt 2 ] && \
1607                 echo "skipping other lfs find --obd test" && return
1608         FILENUM=`$LFIND --recursive $DIR/d56 | sed -n '/^[       ]*1[    ]/p' | wc -l`
1609         OBDUUID=`$LFIND --recursive $DIR/d56 | sed -n '/^[       ]*1:/p' | awk '{print $2}'`
1610         FOUND=`$LFIND -r --obd $OBDUUID $DIR/d56 | wc -l`
1611         [ $FOUND -eq $FILENUM ] || \
1612                 error "lfs find --obd wrong: found $FOUND, expected $FILENUM"
1613         [ `$LFIND -r -v --obd $OBDUUID $DIR/d56 | sed '/^[       ]*1[    ]/d' | \
1614                 sed -n '/^[      ]*[0-9][0-9]*[  ]/p' | wc -l` -eq 0 ] || \
1615                 error "lfs find --obd wrong: should not show file on other obd"
1616         echo "lfs find --obd passed."
1617 }
1618 run_test 56 "check lfs find====================================="
1619
1620 test_59() {
1621         echo "touch 130 files"
1622         for i in `seq 1 130` ; do
1623                 touch $DIR/59-$i
1624         done
1625         echo "rm 130 files"
1626         for i in `seq 1 130` ; do
1627                 rm -f $DIR/59-$i
1628         done
1629         sync
1630         sleep 2
1631         # wait for commitment of removal
1632 }
1633 run_test 59 "verify cancellation of llog records async ========="
1634
1635 test_60() {
1636         echo 60 "llog tests run from kernel mode"
1637         sh run-llog.sh
1638 }
1639 run_test 60 "llog sanity tests run from kernel module =========="
1640
1641 test_61() {
1642         f="$DIR/f61"
1643         dd if=/dev/zero of=$f bs=`page_size` count=1
1644         cancel_lru_locks OSC
1645         multiop $f OSMWUc || error
1646         sync
1647 }
1648 run_test 61 "mmap() writes don't make sync hang ================"
1649
1650 # bug 2330 - insufficient obd_match error checking causes LBUG
1651 test_62() {
1652         f="$DIR/f62"
1653         echo foo > $f
1654         cancel_lru_locks OSC
1655         echo 0x405 > /proc/sys/lustre/fail_loc
1656         cat $f && error "cat succeeded, expect -EIO"
1657         multiop $f Owc && error "multiop succeeded, expect -EIO"
1658         echo 0 > /proc/sys/lustre/fail_loc
1659 }
1660 run_test 62 "verify obd_match failure doesn't LBUG (should -EIO)"
1661
1662 # bug 2319 - osic_wait() interrupted causes crash because of invalid waitq.
1663 test_63() {
1664         MAX_DIRTY_MB=`cat /proc/fs/lustre/osc/*/max_dirty_mb | head -1`
1665         for i in /proc/fs/lustre/osc/*/max_dirty_mb ; do
1666                 echo 0 > $i
1667         done
1668         for i in `seq 10` ; do
1669                 dd if=/dev/zero of=$DIR/f63 bs=8k &
1670                 sleep 5
1671                 kill $!
1672                 sleep 1
1673         done
1674
1675         for i in /proc/fs/lustre/osc/*/max_dirty_mb ; do
1676                 echo $MAX_DIRTY_MB > $i
1677         done
1678         true
1679 }
1680 run_test 63 "Verify osic_wait interruption does not crash ======"
1681
1682 # on the LLNL clusters, runas will still pick up root's $TMP settings,
1683 # which will not be writable for the runas user, and then you get a CVS
1684 # error message with a corrupt path string (CVS bug) and panic.
1685 # We're not using much space, so just stick it in /tmp, which is safe.
1686 OLDTMPDIR=$TMPDIR
1687 OLDTMP=$TMP
1688 TMPDIR=/tmp
1689 TMP=/tmp
1690 OLDHOME=$HOME
1691 [ $RUNAS_ID -ne $UID ] && HOME=/tmp
1692
1693 test_99a() {
1694         mkdir -p $DIR/d99cvsroot
1695         chown $RUNAS_ID $DIR/d99cvsroot
1696         $RUNAS cvs -d $DIR/d99cvsroot init || error
1697 }
1698 run_test 99a "cvs init ========================================="
1699
1700 test_99b() {
1701         [ ! -d $DIR/d99cvsroot ] && run_one 99a
1702         cd /etc/init.d
1703         $RUNAS cvs -d $DIR/d99cvsroot import -m "nomesg" d99reposname vtag rtag
1704 }
1705 run_test 99b "cvs import ======================================="
1706
1707 test_99c() {
1708         [ ! -d $DIR/d99cvsroot ] && run_one 99b
1709         cd $DIR
1710         mkdir -p $DIR/d99reposname
1711         chown $RUNAS_ID $DIR/d99reposname
1712         $RUNAS cvs -d $DIR/d99cvsroot co d99reposname
1713 }
1714 run_test 99c "cvs checkout ====================================="
1715
1716 test_99d() {
1717         [ ! -d $DIR/d99cvsroot ] && run_one 99c
1718         cd $DIR/d99reposname
1719         $RUNAS touch foo99
1720         $RUNAS cvs add -m 'addmsg' foo99
1721 }
1722 run_test 99d "cvs add =========================================="
1723
1724 test_99e() {
1725         [ ! -d $DIR/d99cvsroot ] && run_one 99c
1726         cd $DIR/d99reposname
1727         $RUNAS cvs update
1728 }
1729 run_test 99e "cvs update ======================================="
1730
1731 test_99f() {
1732         [ ! -d $DIR/d99cvsroot ] && run_one 99d
1733         cd $DIR/d99reposname
1734         $RUNAS cvs commit -m 'nomsg' foo99
1735 }
1736 run_test 99f "cvs commit ======================================="
1737
1738 TMPDIR=$OLDTMPDIR
1739 TMP=$OLDTMP
1740 HOME=$OLDHOME
1741
1742 log "cleanup: ======================================================"
1743 if [ "`mount | grep ^$NAME`" ]; then
1744         rm -rf $DIR/[Rdfs][1-9]*
1745         if [ "$I_MOUNTED" = "yes" ]; then
1746                 sh llmountcleanup.sh || error
1747         fi
1748 fi
1749
1750 echo '=========================== finished ==============================='
1751 [ -f "$SANITYLOG" ] && cat $SANITYLOG && exit 1 || true